package testing;

import java.util.ArrayList;
import java.util.List;

import com.silanis.esl.sdk.*;
import com.silanis.esl.sdk.builder.*;

public class MortgageLoan {

	public static void main(String[] args) {
		
		EslClient eslClient = new EslClient(info.API_KEY_SANDBOX, info.API_URL_SANDBOX);
		
		DocumentPackage documentPackage = PackageBuilder.newPackageNamed("Car Loan Application")
		        .withSigner(SignerBuilder.newSignerWithEmail("mail30@mailinator.com")
		                .withFirstName("John")
		                .withLastName("Smith")
		                .withCustomId("Signer1")
		                .signingOrder(0))
		        .withSigner(SignerBuilder.newSignerWithEmail("mail32@mailinator.com")
		                .withFirstName("Patty")
		                .withLastName("Galant")
		                .withCustomId("Signer2")
		                .signingOrder(1))
		        .withDocument(DocumentBuilder.newDocumentWithName("Personal Loan Agreement")
		        		.withId("loan")
		                .fromFile("../mortgage-loan.pdf")
		                .enableExtraction()
		                .withExtractionType(ExtractionType.TEXT_TAGS_ONLY)             
		                .withInjectedField(FieldBuilder.textField()
		                        .withName("applicant_name")
		                        .withValue("John Smith"))
		                .withInjectedField(FieldBuilder.textField()
		                        .withName("applicant_email")
		                        .withValue("mail30@mailinator.com"))
		                .withInjectedField(FieldBuilder.textField()
		                        .withName("application_number")
		                        .withValue("1143216218"))
		                )
		        .withDocument(DocumentBuilder.newDocumentWithName("Personal Loan Agreement")
		        		.withId("loan2")
		                .fromFile("../appraisal-form.pdf")
		                .enableExtraction()
		                .withExtractionType(ExtractionType.TEXT_TAGS_ONLY)             
		                .withInjectedField(FieldBuilder.textField()
		                        .withName("coapplicant_name")
		                        .withValue("Patty Galant"))
		                .withInjectedField(FieldBuilder.textField()
		                        .withName("coapplicant_email")
		                        .withValue("mail32@mailinator.com"))
		                .withInjectedField(FieldBuilder.textField()
		                        .withName("coapplicant_name")
		                        .withValue("Patty Galant"))
		                .withInjectedField(FieldBuilder.textField()
		                        .withName("application_number")
		                        .withValue("1143216218"))
		                )
		        .build();
		
		PackageId packageId = eslClient.createPackage(documentPackage);
		
		List<String> signerIdsList1 = new ArrayList<String>();
		signerIdsList1.add("Signer1");
		signerIdsList1.add("Signer2");
		
		List<String> signerIdsList2 = new ArrayList<String>();
		signerIdsList2.add("Signer2");
		
		com.silanis.esl.sdk.DocumentVisibility visibility = DocumentVisibilityBuilder.newDocumentVisibility()
		        .addConfiguration(DocumentVisibilityConfigurationBuilder.newDocumentVisibilityConfiguration("loan1")
		                .withSignerIds(signerIdsList1))
		        .addConfiguration(DocumentVisibilityConfigurationBuilder.newDocumentVisibilityConfiguration("loan2")
		                .withSignerIds(signerIdsList2))
		        .build();

		eslClient.configureDocumentVisibility(packageId, visibility);
		
		eslClient.sendPackage(packageId);

	}

}
